Index: trunk/LMDZ.MARS/libf/phymars/co2cloud.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/co2cloud.F	(revision 1779)
+++ trunk/LMDZ.MARS/libf/phymars/co2cloud.F	(revision 1816)
@@ -4,5 +4,6 @@
      &                nq,tau,tauscaling,rdust,rice,riceco2,nuice,
      &                rsedcloudco2,rhocloudco2,
-     &                rsedcloud,rhocloud,pzlev,pdqs_sedco2)
+     &                rsedcloud,rhocloud,pzlev,pdqs_sedco2,
+     &                pdu,pu)
 ! to use  'getin'
       use dimradmars_mod, only: naerkind
@@ -10,5 +11,5 @@
       USE ioipsl_getincom
       USE updaterad
-      use conc_mod, only: mmean
+      use conc_mod, only: mmean,rnew
       use tracer_mod, only: nqmx, igcm_co2, igcm_co2_ice,
      &     igcm_dust_mass, igcm_dust_number,igcm_h2o_ice,
@@ -18,12 +19,9 @@
      &     rho_ice_co2,r3n_q,rho_ice,nuice_sed
      
-
       IMPLICIT NONE
-
 
 #include "datafile.h"
 #include "callkeys.h"
 #include "microphys.h"
-
 
 c=======================================================================
@@ -33,5 +31,7 @@
 c  due to timescales smaller than the GCM integration timestep.
 c  microphysics subroutine is improvedCO2clouds.F
-c  
+c  the microphysics time step is a fraction of the physical one
+c  the integer imicroco2 must be set in callphys.def  
+c
 c  The co2 clouds tracers (co2_ice, ccn mass and concentration) are 
 c  sedimented at each microtimestep. pdqs_sedco2 keeps track of the 
@@ -43,5 +43,6 @@
 c
 c 07/2017 J.Audouard
-c Several logicals can be set to .true. in callphys.def
+c Several logicals and integer must be set to .true. in callphys.def 
+c uf not, default values are .false.
 c co2clouds=.true. call this routine
 c co2useh2o=.true. allow the use of water ice particles as CCN for CO2
@@ -49,5 +50,11 @@
 c CLFvaryingCO2=.true. allows a subgrid temperature distribution
 c of amplitude spantCO2(=integer in callphys.def)
+c imicroco2=50 
 c
+c The subgrid Temperature distribution is modulated (0 or 1) by Spiga et
+c al. (GRL 2012) Saturation Index to account for GW propagation or 
+c dissipation upwards.
+c
+c 4D and column opacities are computed using Qext values at 1µm. 
 c=======================================================================
 
@@ -69,5 +76,4 @@
       REAL pdt(ngrid,nlay)       ! tendence temperature des autres param.
       real,intent(in) :: pzlev(ngrid,nlay+1) ! altitude at the boundaries of the layers
-
       real pq(ngrid,nlay,nq)     ! traceur (kg/kg)
       real pdq(ngrid,nlay,nq)    ! tendance avant condensation  (kg/kg.s-1)
@@ -75,5 +81,6 @@
       real rice(ngrid,nlay)    ! Water Ice mass mean radius (m)
                                 ! used for nucleation of CO2 on ice-coated ccns
-      DOUBLE PRECISION rho_ice_co2T(ngrid,nlay)
+      DOUBLE PRECISION rho_ice_co2T(ngrid,nlay) !T-dependant CO2 ice density
+      DOUBLE PRECISION :: myT   ! temperature scalar for co2 density computation
       REAL tau(ngrid,naerkind) ! Column dust optical depth at each point
       REAL tauscaling(ngrid)   ! Convertion factor for dust amount
@@ -86,5 +93,4 @@
       REAL pdtcloudco2(ngrid,nlay)    ! tendence temperature due
                                    ! a la chaleur latente
-
       DOUBLE PRECISION riceco2(ngrid,nlay)    ! Ice mass mean radius (m)
                                ! (r_c in montmessin_2004)
@@ -94,5 +100,6 @@
       real rhocloudco2(ngrid,nlay)  ! Cloud density (kg.m-3)
       real rhocloudco2t(ngrid,nlay)  ! Cloud density (kg.m-3)
-      real  pdqs_sedco2(ngrid) ! CO2 flux at the surface
+      real pdqs_sedco2(ngrid) ! CO2 flux at the surface
+
 c   local:
 c   ------
@@ -101,11 +108,9 @@
       real rhocloud(ngrid,nlay)  ! Cloud density (kg.m-3)
       ! for ice radius computation
-      
-      REAl ccntyp
-      
+        
       ! for time loop
       INTEGER microstep  ! time subsampling step variable
-      INTEGER imicro     ! time subsampling for coupled water microphysics & sedimentation
-      SAVE imicro
+      INTEGER imicroco2     ! time subsampling for coupled water microphysics & sedimentation
+      SAVE imicroco2
       REAL microtimestep ! integration timestep for coupled water microphysics & sedimentation
       SAVE microtimestep
@@ -125,37 +130,30 @@
       INTEGER iq,ig,l,i
       LOGICAL,SAVE :: firstcall=.true.
-      DOUBLE PRECISION Nccnco2, Niceco2,Nco2,mdustJA,ndustJA
-      DOUBLE PRECISION Qccnco2
-      real :: beta
+      DOUBLE PRECISION Nccnco2, Niceco2,Nco2,Qccnco2
+      real :: beta ! for sedimentation
 
       real epaisseur (ngrid,nlay) ! Layer thickness (m)
       real masse (ngrid,nlay) ! Layer mass (kg.m-2)
-      double precision diff,diff0
-      real tempo_traceur_t(ngrid,nlay)
+      real tempo_traceur_t(ngrid,nlay) ! tracers with real-time value in microtimeloop
       real tempo_traceurs(ngrid,nlay,nq)
-      real sav_trac(ngrid,nlay,nq)
+      real sav_trac(ngrid,nlay,nq) !For sedimentation tendancy
       real pdqsed(ngrid,nlay,nq)
-      REAL lw                   !Latent heat of sublimation (J.kg-1) 
-      REAL,save :: l0,l1,l2,l3,l4 !Coeffs for lw
-
-      DOUBLE PRECISION,allocatable,save :: memdMMccn(:,:) ! Nb particules intégré
-      DOUBLE PRECISION,allocatable,save :: memdMMh2o(:,:)
-      DOUBLE PRECISION,allocatable,save :: memdNNccn(:,:)
-      DOUBLE PRECISION :: myT
-!     What we need for Qext reading and tau computation
+
+      DOUBLE PRECISION,allocatable,save :: memdMMccn(:,:) !memory of h2o particles 
+      DOUBLE PRECISION,allocatable,save :: memdMMh2o(:,:) !only if co2useh2o=.true.
+      DOUBLE PRECISION,allocatable,save :: memdNNccn(:,:) !Nb particules H2O intégré 
+     
+!     What we need for Qext reading and tau computation : size distribution
       DOUBLE PRECISION vrat_cld ! Volume ratio
       DOUBLE PRECISION rb_cldco2(nbinco2_cld+1) ! boundary values of each rad_cldco2 bin (m)
       SAVE rb_cldco2
-      DOUBLE PRECISION, PARAMETER :: rmin_cld = 1.e-11 ! Minimum radius (m)
-      DOUBLE PRECISION, PARAMETER :: rmax_cld = 3.e-6 ! Maximum radius (m)
-      DOUBLE PRECISION, PARAMETER :: rbmin_cld =1.e-12
-! Minimum boundary radius (m)
-      DOUBLE PRECISION, PARAMETER :: rbmax_cld = 5.e-6 ! Maximum boundary radius (m)
-
+      DOUBLE PRECISION, PARAMETER :: rmin_cld = 1.e-9 ! Minimum radius (m)
+      DOUBLE PRECISION, PARAMETER :: rmax_cld = 5.e-6 ! Maximum radius (m)
+      DOUBLE PRECISION, PARAMETER :: rbmin_cld =1.e-10! Minimum boundary radius (m)
+      DOUBLE PRECISION, PARAMETER :: rbmax_cld = 2.e-4 ! Maximum boundary radius (m)
       DOUBLE PRECISION dr_cld(nbinco2_cld) ! width of each rad_cldco2 bin (m)
       DOUBLE PRECISION vol_cld(nbinco2_cld) ! particle volume for each bin (m3)
       REAL sigma_iceco2 ! Variance of the ice and CCN distributions
-
-      logical :: file_ok
+      logical :: file_ok !Qext file reading
       double precision :: radv(10000),Qextv1mic(10000)
       double precision :: Qext1bins(100),Qtemp
@@ -163,5 +161,4 @@
       integer :: nelem,lebon1,lebon2,uQext
       save Qext1bins
-      character(len=100) scanline  
       DOUBLE PRECISION n_aer(nbinco2_cld),Rn,No,n_derf,dev2
       DOUBLE PRECISION Qext1bins2(ngrid,nlay)   
@@ -173,12 +170,16 @@
       REAL :: zq(ngrid, nlay,nq)
 
-      REAL :: tcond(ngrid,nlay)
+      DOUBLE PRECISION :: tcond(ngrid,nlay) !CO2 condensation temperature
       REAL ::  zqvap(ngrid,nlay)
-      REAL :: zqice(ngrid,nlay)
+      REAL ::  zqice(ngrid,nlay)
       REAL ::  spant,zdelt ! delta T for the temperature distribution
-      REAL :: zteff(ngrid, nlay)! effective temperature in the cloud,neb
-      REAL :: pqeff(ngrid, nlay, nq)! effective tracers quantities in the cloud
-      REAL :: cloudfrac(ngrid,nlay) ! cloud fraction
-      REAL :: mincloud ! min cloud frac
+      REAL ::  zteff(ngrid, nlay)! effective temperature in the cloud,neb
+      REAL ::  pqeff(ngrid, nlay, nq)! effective tracers quantities in the cloud
+      REAL ::  cloudfrac(ngrid,nlay) ! cloud fraction
+      REAL ::  mincloud ! min cloud frac
+      DOUBLE PRECISION:: rho,zu,NN,gradT !For Saturation Index computation
+      REAL :: pdu(ngrid,nlay),pu(ngrid,nlay) !Wind field zu=pu+pdu*ptimestep
+      DOUBLE PRECISION :: SatIndex(ngrid,nlay),SatIndexmap(ngrid)
+      
 c      logical :: CLFvaryingCO2
 c     ** un petit test de coherence
@@ -197,31 +198,16 @@
         write(*,*) "time subsampling for microphysic ?"
 #ifdef MESOSCALE
-        imicro = 2
+        imicroco2 = 2
 #else
-        imicro = 30
+        imicroco2 = 30
 #endif
-        call getin("imicro",imicro)
-        write(*,*)"imicro = ",imicro
+        call getin("imicroco2",imicroco2)
+        write(*,*)"imicroco2 = ",imicroco2
         
-        microtimestep = ptimestep/real(imicro)
+        microtimestep = ptimestep/real(imicroco2)
         write(*,*)"Physical timestep is",ptimestep 
         write(*,*)"CO2 Microphysics timestep is",microtimestep 
       
-        ! Values for latent heat computation
-        l0=595594d0      
-        l1=903.111d0    
-        l2=-11.5959d0   
-        l3=0.0528288d0
-        l4=-0.000103183d0 
-c$$$        
-c$$$        if (meteo_flux_number .ne. 0) then 
-c$$$
-c$$$        write(*,*) "Warning ! Meteoritic flux of dust is turned on"
-c$$$        write(*,*) "Dust mass = ",meteo_flux_mass 
-c$$$        write(*,*) "Dust number = ",meteo_flux_number
-c$$$        write(*,*) "Are added at the z-level (km)",meteo_alt
-c$$$        write(*,*) "Every timestep in co2cloud.F"
-c$$$         endif
-         
+   
         if (.not. allocated(memdMMccn)) allocate(memdMMccn(ngrid,nlay))
         if (.not. allocated(memdNNccn)) allocate(memdNNccn(ngrid,nlay))
@@ -289,9 +275,9 @@
            ltemp2=abs(radv(:)-rb_cldco2(i+1))
            lebon1=minloc(ltemp1,DIM=1)
-           lebon2=minloc(ltemp2,DIM=1)
+           lebon2=min(minloc(ltemp2,DIM=1),10000)
            nelem=lebon2-lebon1+1.
            Qtemp=0d0
            do l=0,nelem
-              Qtemp=Qtemp+Qextv1mic(lebon1+l) !mean value in the interval
+              Qtemp=Qtemp+Qextv1mic(min(lebon1+l,10000)) !mean value in the interval
            enddo
            Qtemp=Qtemp/nelem
@@ -320,4 +306,5 @@
           write(*,*) "for the CO2 microphysics "
         endif
+
         firstcall=.false.
       ENDIF                     ! of IF (firstcall)
@@ -330,9 +317,4 @@
       subpdqcloudco2(1:ngrid,1:nlay,1:nq) = 0
       subpdtcloudco2(1:ngrid,1:nlay)      = 0
-c$$$
-c$$$       call WRITEDIAGFI(ngrid,"pzlay","pzlay","km",3,
-c$$$     &        pzlay)
-c$$$       call WRITEDIAGFI(ngrid,"pplay","pplay","Pa",3,
-c$$$     &        pplay)
 
       wq(:,:)=0
@@ -353,17 +335,13 @@
       enddo
 
-      !CLFvaryingCO2=.true.
-      
 c-------------------------------------------------------------------
 c   0.  Representation of sub-grid water ice clouds
-c------------------
+c-------------------------------------------------------------------
       IF (CLFvaryingCO2) THEN
+
          spant=spantCO2         ! delta T for the temprature distribution
          mincloud=0.1           ! min cloudfrac when there is ice  
-        ! IF (flagcloudco2) THEN
-        !    write(*,*) "CLFCO2 Delta T", spant
-        !    write(*,*) "CLFCO2 mincloud", mincloud
-        !    flagcloudco2=.false.
-        ! END IF
+         zteff(:,:)=pt(:,:) 
+         cloudfrac(:,:)=mincloud
          
 c-----Tendencies
@@ -382,11 +360,53 @@
          zqvap=zq(:,:,igcm_co2)
          zqice=zq(:,:,igcm_co2_ice)
-!! AS : this routine is not present? 
-!         CALL tcondco2(ngrid,nlay,pplay,zqvap,tcond)
+
+
+         call WRITEDIAGFI(ngrid,"pzlev","pzlev","km",3,
+     &        pzlev)
+         call WRITEDIAGFI(ngrid,"pzlay","pzlay","km",3,
+     &        pzlay)
+         call WRITEDIAGFI(ngrid,"pplay","pplay","Pa",3,
+     &        pplay)
+
+         DO l=12,26
+            ! layers 12 --> 26 ~ 12->85 km
+            DO ig=1,ngrid
+         ! Calcul de N^2 static stability
+            gradT=(zt(ig,l+1)-zt(ig,l))/(pzlev(ig,l+1)-pzlev(ig,l))
+            NN=sqrt(g/zt(iq,l)*(max(gradT,-g/cpp)+g/cpp))
+            !calcul of wind field 
+            zu=pu(ig,l)  + pdu(ig,l)*ptimestep
+!     calcul of background density
+            rho=pplay(ig,l)/(rnew(ig,l)*zt(ig,l))
+            !saturation index
+            SatIndex(ig,l)=sqrt(7.5e-7*150.e3/(2.*pi)*NN/(rho*zu*zu*zu))
+         enddo
+         enddo
+            !Then compute Satindex map 
+            ! layers 12 --> 26 ~ 12->85 km
+         DO ig=1,ngrid
+            SatIndexmap(ig)=maxval(SatIndex(ig,12:26))
+         enddo
+
+         call WRITEDIAGFI(ngrid,"SatIndexmap","SatIndexmap","km",2,
+     &        SatIndexmap)
+
+!Modulate the DeltaT by GW propagation index : 
+         ! Saturation index S in Spiga 2012 paper 
+         !Assuming like in the paper, 
+         !GW phase speed (stationary waves) c=0 m.s-1
+         !lambdaH =150 km
+         !Fo=7.5e-7 J.m-3
+        
+         CALL tcondco2(ngrid,nlay,pplay,zqvap,tcond)
 ! A tester:            CALL tcondco2(ngrid,nlay,pplay,zqvap,tcond)
          zdelt=spant  
-         DO l=1,nlay
-            DO ig=1,ngrid
-               IF (tcond(ig,l) .ge. (zt(ig,l)+zdelt)) THEN !Toute la fraction est saturée
+           DO ig=1,ngrid
+              
+            if (SatIndexmap(ig) .le. 0.1) THEN
+              DO l=1,nlay-1
+         
+               IF (tcond(ig,l) .ge. (zt(ig,l)+zdelt) 
+     &             .or. tcond(ig,l) .le. 0 ) THEN !Toute la fraction est saturée
                   zteff(ig,l)=zt(ig,l)
                   cloudfrac(ig,l)=1.
@@ -397,15 +417,19 @@
                   cloudfrac(ig,l)=(tcond(ig,l)-zt(ig,l)+zdelt)/
      &                 (2.0*zdelt)
-                  zteff(ig,l)=(tcond(ig,l)+zt(ig,l)-zdelt)/2. !Ja Temperature moyenne de la fraction nuageuse 
-                  
-               END IF
+                  zteff(ig,l)=(tcond(ig,l)+zt(ig,l)-zdelt)/2. !Temperature moyenne de la fraction nuageuse 
+               END IF           !ig if (tcond(ig,l) ...
                zteff(ig,l)=zteff(ig,l)-pdt(ig,l)*ptimestep
                IF (cloudfrac(ig,l).le. mincloud) THEN
                   cloudfrac(ig,l)=mincloud
-               ELSE IF (cloudfrac(ig,l).ge. 1) THEN
+               ELSE IF (cloudfrac(ig,l).gt. 1) THEN
                   cloudfrac(ig,l)=1.
                END IF
             ENDDO
-         ENDDO
+         ELSE
+!SatIndex not favorable for GW : leave pt untouched
+            zteff(ig,l)=pt(ig,l)
+            cloudfrac(ig,l)=mincloud
+         END IF                 ! of if(SatIndexmap...
+      ENDDO
 !     Totalcloud frac of the column missing here
 c-----------------------
@@ -417,148 +441,68 @@
             END DO
          END DO
-      END IF                    ! end if (CLFvaryingco2)--------------------------------------------
-c   1.  Tendencies: 
-c------------------
-  
-c------ Effective tracers quantities in the cloud fraction
-        IF (CLFvaryingCO2) THEN     
-           pqeff(:,:,:)=pq(:,:,:) ! prevent from buggs (A. Pottier)
-   
-c           pqeff(:,:,igcm_ccn_mass) =pq(:,:,igcm_ccn_mass)/
-c     &                                cloudfrac(:,:)
-c           pqeff(:,:,igcm_ccn_number)= 
-c     &     pq(:,:,igcm_ccn_number)/cloudfrac(:,:)
-c           pqeff(:,:,igcm_h2o_ice)= pq(:,:,igcm_h2o_ice)/
-c     &                               cloudfrac(:,:)
-           pqeff(:,:,igcm_ccnco2_mass) =pq(:,:,igcm_ccnco2_mass)/
-     &                                cloudfrac(:,:)
-           pqeff(:,:,igcm_ccnco2_number)= 
-     &     pq(:,:,igcm_ccnco2_number)/cloudfrac(:,:)
-           pqeff(:,:,igcm_co2_ice)= pq(:,:,igcm_co2_ice)/
-     &                               cloudfrac(:,:)
-
-        ELSE
-           pqeff(:,:,:)=pq(:,:,:)
-c           pqeff(:,:,igcm_ccn_mass)= pq(:,:,igcm_ccn_mass)
-c           pqeff(:,:,igcm_ccn_number)= pq(:,:,igcm_ccn_number)
-c           pqeff(:,:,igcm_h2o_ice)= pq(:,:,igcm_h2o_ice)
-c           pqeff(:,:,igcm_ccnco2_mass)= pq(:,:,igcm_ccnco2_mass)
-c           pqeff(:,:,igcm_ccnco2_number)= pq(:,:,igcm_ccnco2_number)
-c           pqeff(:,:,igcm_co2_ice)= pq(:,:,igcm_co2_ice)
-        END IF      
-        tempo_traceur_t(1:ngrid,1:nlay)=zteff(1:ngrid,1:nlay)
-      tempo_traceurs(1:ngrid,1:nlay,1:nq)=pqeff(1:ngrid,1:nlay,1:nq)
-
+      END IF                    ! end if (CLFvaryingco2)
 c------------------------------------------------------------------
-c Time subsampling for microphysics 
+c microtimestep timeloop for microphysics:
+c 0.Stepped entry for tendancies
+c 1.Compute sedimentation and update tendancies
+c 2.Call co2clouds microphysics
+c 3.Update tendancies 
 c------------------------------------------------------------------
-      DO microstep=1,imicro 
+      DO microstep=1,imicroco2
 c------ Temperature tendency subpdt
-        ! Each microtimestep we give the cloud scheme a stepped entry subpdt instead of pdt
         ! If imicro=1 subpdt is the same as pdt
-        DO l=1,nlay
-          DO ig=1,ngrid
-
-             subpdt(ig,l) = subpdt(ig,l)
-     &            + pdt(ig,l)   ! At each micro timestep we add pdt in order to have a stepped entry
-             subpdq(ig,l,igcm_dust_mass) = 
-     &            subpdq(ig,l,igcm_dust_mass)
-     &            + pdq(ig,l,igcm_dust_mass)
-             subpdq(ig,l,igcm_dust_number) = 
-     &            subpdq(ig,l,igcm_dust_number)
-     &            + pdq(ig,l,igcm_dust_number)
-             subpdq(ig,l,igcm_ccnco2_mass) = 
-     &            subpdq(ig,l,igcm_ccnco2_mass)
-     &            + pdq(ig,l,igcm_ccnco2_mass)
-             subpdq(ig,l,igcm_ccnco2_number) = 
-     &            subpdq(ig,l,igcm_ccnco2_number)
-     &            + pdq(ig,l,igcm_ccnco2_number)
-             subpdq(ig,l,igcm_co2_ice) = 
-     &            subpdq(ig,l,igcm_co2_ice)
-     &            + pdq(ig,l,igcm_co2_ice)
-             subpdq(ig,l,igcm_co2) = 
-     &            subpdq(ig,l,igcm_co2)
-     &            + pdq(ig,l,igcm_co2)
-             subpdq(ig,l,igcm_h2o_ice) = 
-     &            subpdq(ig,l,igcm_h2o_ice)
-     &            + pdq(ig,l,igcm_h2o_ice)
-             subpdq(ig,l,igcm_ccn_mass) = 
-     &            subpdq(ig,l,igcm_ccn_mass)
-     &            + pdq(ig,l,igcm_ccn_mass)
-             subpdq(ig,l,igcm_ccn_number) = 
-     &            subpdq(ig,l,igcm_ccn_number)
-     &            + pdq(ig,l,igcm_ccn_number)
-          ENDDO
-       ENDDO
-
-c add meteoritic flux of dust (old version)
-cNew version (John Plane values) are added in improvedCO2clouds
-    !convert meteo_alt (in km) to z-level 
-        !pzlay altitudes of the layers
-c$$$!zlev altitudes (nlayl+1) of the boundaries
-c$$$       if (meteo_flux_number .ge. 0) then 
-c$$$          do ig=1, ngrid
-c$$$             l=1
-c$$$             do  while ( (((meteo_alt .ge. pplev(ig,l)) .and.
-c$$$     &            (meteo_alt .le. pplev(ig,l+1))) .eq. .false.)
-c$$$     &            .and. (l .lt. nlay) )
-c$$$                l=l+1
-c$$$             enddo
-c$$$             meteo_lvl=l
-c$$$             subpdq(ig,meteo_lvl,igcm_dust_mass)=
-c$$$     &            subpdq(ig,meteo_lvl,igcm_dust_mass)
-c$$$     &            +meteo_flux_mass
-c$$$             subpdq(ig,meteo_lvl,igcm_dust_number)=
-c$$$     &            subpdq(ig,meteo_lvl,igcm_dust_number)
-c$$$     &            +meteo_flux_number
-c$$$          enddo
-c$$$       endif
-c-------------------------------------------------------------------
-c   2.  Main call to the cloud schemes:
-c------------------------------------------------
-      CALL improvedCO2clouds(ngrid,nlay,microtimestep,
-     &     pplay,pzlev,zteff,subpdt,
-     &     pqeff,subpdq,subpdqcloudco2,subpdtcloudco2,
-     &     nq,tauscaling,memdMMccn,memdMMh2o,memdNNccn)
-c-------------------------------------------------------------------
-c   3.  Updating tendencies after cloud scheme:
-c-----------------------------------------------
-          DO l=1,nlay
+         DO l=1,nlay
             DO ig=1,ngrid
-               subpdt(ig,l) =
-     &              subpdt(ig,l) + subpdtcloudco2(ig,l)
-               subpdq(ig,l,igcm_dust_mass) =
+               subpdt(ig,l) = subpdt(ig,l)
+     &              + pdt(ig,l) ! At each micro timestep we add pdt in order to have a stepped entry
+               subpdq(ig,l,igcm_dust_mass) = 
      &              subpdq(ig,l,igcm_dust_mass)
-     &              + subpdqcloudco2(ig,l,igcm_dust_mass)
-               subpdq(ig,l,igcm_dust_number) =
+     &              + pdq(ig,l,igcm_dust_mass)
+               subpdq(ig,l,igcm_dust_number) = 
      &              subpdq(ig,l,igcm_dust_number)
-     &              + subpdqcloudco2(ig,l,igcm_dust_number)
-               subpdq(ig,l,igcm_ccnco2_mass) =
+     &              + pdq(ig,l,igcm_dust_number)
+
+               subpdq(ig,l,igcm_ccnco2_mass) = 
      &              subpdq(ig,l,igcm_ccnco2_mass)
-     &              + subpdqcloudco2(ig,l,igcm_ccnco2_mass)
-               subpdq(ig,l,igcm_ccnco2_number) =
+     &              + pdq(ig,l,igcm_ccnco2_mass)
+               subpdq(ig,l,igcm_ccnco2_number) = 
      &              subpdq(ig,l,igcm_ccnco2_number)
-     &              + subpdqcloudco2(ig,l,igcm_ccnco2_number)
-               subpdq(ig,l,igcm_co2_ice) =
+     &              + pdq(ig,l,igcm_ccnco2_number)
+
+               subpdq(ig,l,igcm_co2_ice) = 
      &              subpdq(ig,l,igcm_co2_ice)
-     &              + subpdqcloudco2(ig,l,igcm_co2_ice)
-               subpdq(ig,l,igcm_co2) =
+     &              + pdq(ig,l,igcm_co2_ice)
+               subpdq(ig,l,igcm_co2) = 
      &              subpdq(ig,l,igcm_co2)
-     &              + subpdqcloudco2(ig,l,igcm_co2)
-               subpdq(ig,l,igcm_h2o_ice) =
+     &              + pdq(ig,l,igcm_co2)
+
+               subpdq(ig,l,igcm_h2o_ice) = 
      &              subpdq(ig,l,igcm_h2o_ice)
-     &              + subpdqcloudco2(ig,l,igcm_h2o_ice)
-               subpdq(ig,l,igcm_ccn_mass) =
+     &              + pdq(ig,l,igcm_h2o_ice)
+               subpdq(ig,l,igcm_ccn_mass) = 
      &              subpdq(ig,l,igcm_ccn_mass)
-     &              + subpdqcloudco2(ig,l,igcm_ccn_mass)
-               subpdq(ig,l,igcm_ccn_number) =
+     &              + pdq(ig,l,igcm_ccn_mass)
+               subpdq(ig,l,igcm_ccn_number) = 
      &              subpdq(ig,l,igcm_ccn_number)
-     &              + subpdqcloudco2(ig,l,igcm_ccn_number)
+     &              + pdq(ig,l,igcm_ccn_number)
             ENDDO
          ENDDO
-        
-!Sedimentation
-!Update traceurs, compute rsed 
+c- Effective tracers quantities in the cloud fraction
+         IF (CLFvaryingCO2) THEN     
+            pqeff(:,:,:)=pq(:,:,:) ! prevent from buggs (A. Pottier)
+            pqeff(:,:,igcm_ccnco2_mass) =pq(:,:,igcm_ccnco2_mass)/
+     &           cloudfrac(:,:)
+            pqeff(:,:,igcm_ccnco2_number)= 
+     &           pq(:,:,igcm_ccnco2_number)/cloudfrac(:,:)
+            pqeff(:,:,igcm_co2_ice)= pq(:,:,igcm_co2_ice)/
+     &           cloudfrac(:,:)
+         ELSE
+            pqeff(:,:,:)=pq(:,:,:)
+         END IF  
        
+c------------------------------------------------------
+c 1.SEDIMENTATION : update tracers, compute parameters,
+c   call to sedimentation routine, update tendancies
+c------------------------------------------------------
        DO l=1, nlay
           DO ig=1,ngrid             
@@ -567,5 +511,4 @@
              tempo_traceurs(ig,l,:)=pqeff(ig,l,:)
      &            +subpdq(ig,l,:)*microtimestep
-
              rho_ice_co2T(ig,l)=1000.*(1.72391-2.53e-4*
      &            tempo_traceur_t(ig,l)-2.87e-6*
@@ -578,62 +521,42 @@
              Qccnco2=max(tempo_traceurs(ig,l,igcm_ccnco2_mass),
      &            1.e-30)
-             mdustJA= tempo_traceurs(ig,l,igcm_dust_mass) 
-             ndustJA=tempo_traceurs(ig,l,igcm_dust_number)
-             if ((Nccnco2 .lt. tauscaling(ig)) .or. (Qccnco2 .lt. 
-     &            1.e-30 *tauscaling(ig))) then 
-                rdust(ig,l)=1.e-10
-             else
-                rdust(ig,l)=(3./4./pi/2500.*Qccnco2/Nccnco2)**(1./3.)
-                rdust(ig,l)=max(rdust(ig,l),1.e-10) 
-c     rdust(ig,l)=min(rdust(ig,l),5.e-6)   
-             end if
-             rhocloudco2t(ig,l) = (Niceco2 *rho_ice_co2 
-     &            + Qccnco2*tauscaling(ig)*rho_dust)
-     &            / (Niceco2 + Qccnco2*tauscaling(ig))
-             
+             call updaterice_microco2(Niceco2,
+     &            Qccnco2,Nccnco2,
+     &            tauscaling(ig),riceco2(ig,l),rhocloudco2t(ig,l))
+             if (Niceco2 .le. 1.e-25 
+     &            .or. Nccnco2*tauscaling(ig) .le. 1) THEN
+                riceco2(ig,l)=1.e-9
+             endif
              rhocloudco2t(ig,l)=min(max(rhocloudco2t(ig,l)
      &            ,rho_ice_co2),rho_dust)
-             riceco2(ig,l)=(Niceco2*3.0/
-     &            (4.0*rho_ice_co2*pi*Nccnco2
-     &            *tauscaling(ig)) +rdust(ig,l)*rdust(ig,l)
-     &            *rdust(ig,l))**(1.0/3.0)
-             riceco2(ig,l)=max(1.e-10,riceco2(ig,l))
-             
              rsedcloudco2(ig,l)=max(riceco2(ig,l)*
      &            (1.+nuiceco2_sed)*(1.+nuiceco2_sed)*(1.+nuiceco2_sed),
-     &            rdust(ig,l))
-             
+     &            riceco2(ig,l))
           ENDDO
        ENDDO
-       
-!     Gravitational sedimentation
-       
+!     Gravitational sedimentation       
        sav_trac(:,:,igcm_co2_ice)=tempo_traceurs(:,:,igcm_co2_ice)
        sav_trac(:,:,igcm_ccnco2_mass)=
      &      tempo_traceurs(:,:,igcm_ccnco2_mass)
        sav_trac(:,:,igcm_ccnco2_number)=
-     &      tempo_traceurs(:,:,igcm_ccnco2_number)
-       
-      call newsedim(ngrid,nlay,ngrid*nlay,ngrid*nlay,
+     &      tempo_traceurs(:,:,igcm_ccnco2_number) 
+       !We save actualized tracer values to compute sedimentation tendancies
+       call newsedim(ngrid,nlay,ngrid*nlay,ngrid*nlay,
      &     microtimestep,pplev,masse,epaisseur,tempo_traceur_t,
      &     rsedcloudco2,rhocloudco2t,
      &     tempo_traceurs(:,:,igcm_co2_ice),wq,beta) !  3 traceurs
-      
 !     sedim at the surface of co2 ice : keep track of it for physiq_mod
       do ig=1,ngrid 
          pdqs_sedco2(ig)=pdqs_sedco2(ig)+ wq(ig,1)/microtimestep
       end do
-
       call newsedim(ngrid,nlay,ngrid*nlay,ngrid*nlay,
      &     microtimestep,pplev,masse,epaisseur,tempo_traceur_t,
      &     rsedcloudco2,rhocloudco2t,
      &     tempo_traceurs(:,:,igcm_ccnco2_mass),wq,beta) 
-      
       call newsedim(ngrid,nlay,ngrid*nlay,ngrid*nlay,
      &     microtimestep,pplev,masse,epaisseur,tempo_traceur_t,
      &     rsedcloudco2,rhocloudco2t,
      &     tempo_traceurs(:,:,igcm_ccnco2_number),wq,beta) 
-            
-      DO l = 1, nlay !Compute tendencies
+      DO l = 1, nlay            !Compute tendencies
          DO ig=1,ngrid
             pdqsed(ig,l,igcm_ccnco2_mass)=
@@ -648,7 +571,6 @@
          ENDDO
       ENDDO
-            !pdqsed est la tendance due a la sedimentation
-     
-      DO l=1,nlay
+      !update subtimestep tendencies with sedimentation input
+        DO l=1,nlay
          DO ig=1,ngrid
             subpdq(ig,l,igcm_ccnco2_mass) =
